searchNodes=[{"doc":"Module that wraps functions from libnice.","ref":"ExLibnice.html","title":"ExLibnice","type":"module"},{"doc":"Adds a new stream with n_components components. name is optional but not passing it will influence on SDP string format, see generate_local_sdp/1.","ref":"ExLibnice.html#add_stream/3","title":"ExLibnice.add_stream/3","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"ExLibnice.html#child_spec/1","title":"ExLibnice.child_spec/1","type":"function"},{"doc":"Starts gathering candidates process for stream with id stream_id.May cause the parent process receive following messages:{:new_candidate_full, candidate} - new local candidate{:candidate_gathering_done, stream_id} - gathering candidates for stream with stream_id has been done","ref":"ExLibnice.html#gather_candidates/2","title":"ExLibnice.gather_candidates/2","type":"function"},{"doc":"Generates a SDP string containing the local candidates and credentials for all streams and components.Notice that:local candidates will be present in the result SDP only if gather_candidates/1 has been invoked previouslyif a stream is created without a name the 'm' line will contain '-' mark but SDP in this form will not be parsable by parse_remote_sdp/2","ref":"ExLibnice.html#generate_local_sdp/1","title":"ExLibnice.generate_local_sdp/1","type":"function"},{"doc":"Returns local credentials for stream with id stream_id.","ref":"ExLibnice.html#get_local_credentials/2","title":"ExLibnice.get_local_credentials/2","type":"function"},{"doc":"Parses a remote SDP string setting credentials and remote candidates for proper streams and components. It is important that m line does not contain - mark but the name of the stream.","ref":"ExLibnice.html#parse_remote_sdp/2","title":"ExLibnice.parse_remote_sdp/2","type":"function"},{"doc":"Indicates that all remote candidates for stream with id stream_id have been passed.After receiving this message components can change their state to FAILED if all their connectivity checks have failed. Not sending this message will cause components stay in CONNECTING state. (In fact there is a bug and components can change their state to FAILED even without sending this message. Please refer to #120","ref":"ExLibnice.html#peer_candidate_gathering_done/2","title":"ExLibnice.peer_candidate_gathering_done/2","type":"function"},{"doc":"Removes stream with id stream_id.","ref":"ExLibnice.html#remove_stream/2","title":"ExLibnice.remove_stream/2","type":"function"},{"doc":"Sends payload on component with id component_id in stream with id stream_id. Payload has to be in a binary format.","ref":"ExLibnice.html#send_payload/4","title":"ExLibnice.send_payload/4","type":"function"},{"doc":"Sets remote candidate for component with id component_id in stream with id stream_id. Candidate has to be passed as SDP string.May cause the parent process receive following messages:{:new_remote_candidate_full, candidate} - new remote (prflx) candidate{:new_selected_pair, stream_id, component_id, lfoundation, rfoundation} - new selected pair{:component_state_failed, stream_id, component_id} - component with id component_id in stream with id stream_id has changed state to FAILED{:component_state_ready, stream_id, component_id} - component with id component_id in stream with id stream_id has changed state to READY i.e. it is ready to receive and send data","ref":"ExLibnice.html#set_remote_candidate/4","title":"ExLibnice.set_remote_candidate/4","type":"function"},{"doc":"Sets remote credentials for stream with stream_id. Credentials have to be passed in form of ufrag pwd.","ref":"ExLibnice.html#set_remote_credentials/3","title":"ExLibnice.set_remote_credentials/3","type":"function"},{"doc":"Spawns new process responsible for interacting with libnice.","ref":"ExLibnice.html#start_link/1","title":"ExLibnice.start_link/1","type":"function"},{"doc":"Type describing ExLibnice configuration.It's a keyword list containing the following keys:parent - pid of calling processstun_servers - list of stun servers in form of ip:portcontrolling_mode - refer to RFC 8445 section 4 - Controlling and Controlled Agentmin_port..max_port - the port range to use. Pass 0..0 if you not willing to set it.Passed port range will be set for each newly added stream. At this moment it is not possible to set port range per stream.","ref":"ExLibnice.html#t:opts_t/0","title":"ExLibnice.opts_t/0","type":"type"},{"doc":"ExLibnice","ref":"readme.html","title":"ExLibnice","type":"extras"},{"doc":"The package can be installed by adding ex_libnice to your list of dependencies in mix.exs:def deps do [ {:ex_libnice, &quot;~&gt; 0.1.0&quot;} ] end","ref":"readme.html#installation","title":"ExLibnice - Installation","type":"extras"},{"doc":"Basically this library works similarly to libnice except that it doesn't support some features yet (e.g. TURN servers).Example flow can look in the following way (this is not complete i.e. runnable example).Listed functions must be invoked on both peers.# Init ExLibnice {:ok, ice} = ExLibnice.start_link(self(), [&quot;64.233.161.127:19302&quot;], [], controlling_mode, 0..65_535) # Add stream, get local credentials {:ok, stream_id} = ExLibnice.add_stream(ice, 1, &quot;audio&quot;) {:ok, credentials} = ExLibnice.get_local_credentials(ice, stream_id) # Send local credentials to the remote peer :socket.send(peer_socket, credentials)# Receive remote credentials and set them on ExLibnice {:ok, credentials} = :socket.recv(peer_socket) :ok = ExLibnice.set_remote_credentials(ice, peer_credentials, stream_id) # Start gathering candidates :ok = ExLibnice.gather_candidates(ice, stream_id)# Now we should prepare for receiving messages in form of `{:new_candidate_full, candidate}` # and send them to the remote peer. If module that runs ExLibnice is a GenServer we can use # handle_info/2 callback @impl true def handle_info({:new_candidate_full, candidate}, {peer_socket: peer_socket} = state) do :socket.send(peer_socket, {:peer_new_candidate_full, candidate}) end# Set received peer candidates. :ok = ExLibnice.set_remote_candidate(ice, peer_candidate, stream_id, 1)This will start connectivity checks. Receiving message {:component_state_ready, stream_id, component_id} indicates that the given component in the given stream is ready to send and receive messages.For more complete examples please refer to membrane_ice_plugin where we use ex_libnice or our integration test.","ref":"readme.html#usage","title":"ExLibnice - Usage","type":"extras"},{"doc":"Copyright 2020, Software MansionLicensed under the Apache License, Version 2.0","ref":"readme.html#copyright-and-license","title":"ExLibnice - Copyright and License","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright 2020 Software Mansion Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]